// StrCalc - MCFunc (Impl)

#ifndef IG_MODULECLASS_FUNC_IMPL_AS
#define IG_MODULECLASS_FUNC_IMPL_AS

#include "Mo/abdata/list.as"
#include "Mo/abdata/mod_pvalptr.as"

#include "MCBlock.as"
#include "MCVector.as"

#module MCFuncImpl \
	mName, miPlugin, miFunc, miEnv, mType, \
	mBody, msExpr, mcntPrms, mPrmlist, \
	mEvaler, mIdxEvaler, \
	mSuperFunc, mArglist

#include "header_inner.as"

;#define true  1
;#define false 0

#define global STR_ARGVAR_PREFIX "#argv_"

#enum FuncType_Undefined = 0		// FuncType ɂČĂяo@ς
#enum FuncType_Internal
#enum FuncType_Block
#enum FuncType_Bound
#enum FuncType_String
#enum FuncType_MAX

//##############################################################################
//                RXgN^EfXgN^
//##############################################################################
//------------------------------------------------
// RXgN^
//------------------------------------------------
#define global funcImpl_New(%1, %2, %3, %4 = 0, %5, %6 = false) newmod %1, MCFuncImpl@, %2, %3, %4, %5, %6
#modinit int iPlugin, str funcname, int cntPrms, int iEnv, int bInternal
	mName      = funcname				// ֐
	miPlugin   = iPlugin				// vOC
	miFunc     = getaptr(thismod)		// ֐ID
	mcntPrms   = cntPrms				// ̌ (ꂽ̌)
	miEnv      = iEnv					// 
	mType      = (bInternal == true)	// FuncType_* (́Agݍ(internal) or `(undefined))
	
	mBody      = 0				// ֐{ [depends on(mType); block or string]
	mPrmlist   = listNull		// ̎ʎqXg (ȗ)
	
	mArglist   = assocNull		// ꂽXg (mType == FuncType_Bound)
;	mSuperFunc = FuncValue()	// O̊֐   (V)
	
	if ( mName == "" ) {
		mName = "#" + miFunc
	}
	
;	mEvaler    = nullmod
	mIdxEvaler = -1
	
	return miFunc
	
//------------------------------------------------
// fXgN^
//------------------------------------------------
#define global funcImpl_Delete(%1) delmod %1

//##############################################################################
//                o֐
//##############################################################################
//------------------------------------------------
// Ăяo
// 
// @ FuncType_Internal Ȃ痈Ȃ
//------------------------------------------------
#modcfunc funcImpl_Call var thisEvaler, var resVt, int thisAssoc, int arglist,  local result, local tkQueue, local evaler,  local tmp
	
	assert ( mType != FuncType_Internal && mType != FuncType_Bound )
	
	switch ( mType )
		case FuncType_String:	// sOɉ͂
			
			StrCalc_Compile tkQueue, mBody
			if ( stat == failure ) {
				dbgout "[Error] when ֐̒`\n֐ " + mName + " ̒`̉͂Ɏs܂B"
				funcImpl_Undef thismod
				swbreak
			}
			funcImpl_SetExpr thismod, tkQueue	// FuncType_Block  FuncType_Undefined ɂȂ
			swcontinue							// ĕ
			
		case FuncType_Block:
			block_GetQueue mBody, tkQueue
			return evaler_ProcFuncUserdefImpl( thisEvaler, thisAssoc, miFunc, tkQueue, arglist, mPrmlist, resVt, miEnv )
			
		case FuncType_Undefined:
		default:
			logmes "[Error] when [U`֐̎s(MCFuncImpl::Call)\ns`̊֐ " + mName + " s悤ƂĂ"
			return 0
	swend
	assert
	
//------------------------------------------------
// ֐{̂ݒ肷
//------------------------------------------------
// `
#modfunc funcImpl_Undef
	mType = FuncType_Undefined
;	mBody = 0
	
	msExpr = "(undefined)"
	return
	
// s ()
#modfunc funcImpl_SetExpr array tkQueue,  local iBlock
	iBlock = new_block( miEnv )			// 𐶐
	block_PushExpr iBlock, tkQueue
	funcImpl_SetBlock thismod, iBlock
	return
	
// 
#modfunc funcImpl_SetBlock int iBlock
	if ( iBlock == blockNull ) {
		funcImpl_Undef thismod
		
	} else {
		mType = FuncType_Block
		mBody = iBlock
		
		msExpr = 0		// ŉ
	}
	return
	
// 
#modfunc funcImpl_SetBodyString str sExpr
	mType = FuncType_String
	mBody = sExpr
	
	msExpr = sExpr
	return
	
//------------------------------------------------
// 
// 
// @ this A֐ fSrc  arglist 𑩔֐ɂB
// @	this := fSrc[arglist];
// @ 	this := (fSrc.super)[fSrc.arglist + arglist];
//------------------------------------------------
#modfunc funcImpl_Bind int src, int arglist,  local srcArglist, local fSrc
	fSrc = func_allInsts(src)
	
	// arglist
	srcArglist = funcImpl_GetArglist(fSrc)
	mArglist   = which( srcArglist != assocNull, vector_Cat( srcArglist, arglist ), vector_Slice(arglist) )
	
	// ̊֐ (Bound Ȃ炻̌̊֐𓾂)
	mSuperFunc = which( funcImpl_IsBound(fSrc), funcImpl_GetSuperFunc(fSrc), funcImpl_GetFuncValue(fSrc) )
	mType = FuncType_Bound
	
	return
	
// ^ƌ
#modcfunc funcImpl_Unbind var arglist,  local src
	arglist = vector_Cat( mArglist, arglist )	// A; ^ϐ arglist ̂Ɍʂ^
	return mSuperFunc							// ̊֐Ԃ
	
//------------------------------------------------
// Xg
//------------------------------------------------
#modfunc funcImpl_SetPrmlist array prmlist
	mPrmlist = new_list()
	repeat ( mcntPrms )
		list_add mPrmlist, prmlist(cnt)
	loop
	return
	
#modcfunc funcImpl_GetPrmlist
	return mPrmlist
	
//------------------------------------------------
// Zuo
//------------------------------------------------
#modfunc funcImpl_GetEvaler var evaler, int iEnv
	assert ( mType == FuncType_Internal || mType == FuncType_Block )
	
	// 
	if ( mIdxEvaler < 0 ) {
		mEvaler    = 0
		mIdxEvaler = 0
		
		evaler_New mEvaler, mBody, iEnv
		
	} else {
		// Ă΂̂܂ܕԂ
		switch ( evaler_CurMode(mEvaler(mIdxEvaler)) )
			// p(yield) => ̂܂ܕԂ
			case RunMode_Yield:
				swbreak
				
			// sI => 폜Ă쐬
			case RunMode_End:
				evaler_Delete mEvaler(mIdxEvaler)
				mIdxEvaler --
			//	fall-through
				
			default:
				evaler_New mEvaler, mBody, iEnv
				mIdxEvaler ++
				swbreak
		swend
	}
	
	evaler = mEvaler(mIdxEvaler)
	return
	
//------------------------------------------------
// oϐf[^Ԃ
//------------------------------------------------
#modcfunc funcImpl_GetName
	return mName
	
#modcfunc funcImpl_GetPlugin
	return miPlugin
	
#modcfunc funcImpl_GetFuncId
	return miFunc
	
#modcfunc funcImpl_GetFuncValue@MCFuncImpl
	return FuncValue( miPlugin, miFunc )
	
#modcfunc funcImpl_GetCntPrms
	return mcntPrms
	
#modcfunc funcImpl_GetBodyAsString  local result
	if ( msExpr != "" ) { return msExpr }
	
	switch ( mType )
		xcase FuncType_Undefined: result = "(undefined)"
		xcase FuncType_Internal:  result = "(internal)" 
		xcase FuncType_Block:     result = block_GetDecoded( mBody )
		xcase FuncType_Bound:     result = "(bound)"		// 񉻏͖
		xcase FuncType_String:    result = mBody
	swend
	
	msExpr = result
	return msExpr
	
#modcfunc funcImpl_IsDefined
	return (mType != FuncType_Undefined)
	
#modcfunc funcImpl_IsInternal
	return (mType == FuncType_Internal)
	
#modcfunc funcImpl_IsBound
	return (mArglist != assocNull)
	
#modcfunc funcImpl_GetEnv
	return miEnv
	
#modcfunc funcImpl_GetArglist
	return mArglist
	
#modcfunc funcImpl_GetSuperFunc
	return mSuperFunc
	
#global

#endif
