// Klac - vector

#ifndef IG_KLAC_MODULECLASS_VECTOR_AS
#define IG_KLAC_MODULECLASS_VECTOR_AS

#include "Mo/abdata/list.as"

#include "MCVar.as"
#include "MCAssoc.as"

// vector ̑샂W[

//##############################################################################
//                W[
//##############################################################################
#module MCVector

#include "enum_valtype.as"
#include "header_inner.as"

#define VAR_TEMP _stt_temp@MCVector

// @static
	dim VAR_TEMP
	
//##########################################################
//                \zE
//##########################################################
//------------------------------------------------
// \z
//------------------------------------------------
#deffunc vector_New var self,  int iEnv
	assoc_New    self, iEnv
	assoc_DefVar self, "prototype", (stt_assoc_vector), Valtype_Assoc
	
	vector_ctor  self
	
	return self
	
// \z
#deffunc vector_Ctor int self
	assoc_DefVar self, "#impl",      new_list(), Valtype_Int		// ̂̔z
	assoc_DefVar self, "#bExpanded", false,      Valtype_Bool		// WJς݂H
	return
	
// ֐`
#defcfunc new_vector int iEnv,  local obj
	vector_New obj, iEnv
	return obj
	
//------------------------------------------------
// j
//------------------------------------------------
#deffunc vector_Delete int self
	assoc_Delete self
	return
	
//##########################################################
//                
//##########################################################
//------------------------------------------------
// vf
// 
// @ l Value (val, val_vt) ɂāA
// @	(Value == vector[k]) == true 𖞂 k ԋpB
//------------------------------------------------
#defcfunc vector_Find int self, var resVt, var val, var val_vt, int iEnv,  local result, local tmp, local tmp_vt, local evaler, local bEq
	result = -1		// l
	
	repeat vector_Size(self)
		tmp = var_GetValue( vector_Get(self, cnt), tmp_vt )
		
		if ( val_vt == Valtype_Assoc ) {		// Az̉Z
			bEq = evaler_ProcOpBin_AssocByName( stt_simple_evaler, val, resVt, OpFuncName("Eq"), tmp, tmp_vt )
		} else {
			bEq = evaler_ProcOpBin_Relation( stt_simple_evaler, BinOp_Eq, resVt, val, val_vt, tmp, tmp_vt )	// == Z
		}
		
		if ( bEq == true ) {
			result = cnt
			break
		}
	loop
	
	resVt  = Valtype_Int
	return result
	
//##########################################################
//                擾
//##########################################################
//------------------------------------------------
// 𓾂
//------------------------------------------------
#define global vector_GetEnv assoc_GetEnv

//------------------------------------------------
// oFϐ̃Xg
//------------------------------------------------
#defcfunc vector_GetMember_impl@MCVector int self
	return assoc_Find( self, "#impl" )
	
#defcfunc vector_GetImpl@MCVector int self
	return var_Get(vector_GetMember_impl(self))
	
//------------------------------------------------
// vf
//------------------------------------------------
#defcfunc vector_Size int self
	if ( self == 0 ) { return 0 }
	return list_size( vector_GetImpl(self) )
	
#define global vector_Empty not vector_Size
	
//------------------------------------------------
// vf擾
// 
// @ ϐ iVar Ԃ
//------------------------------------------------
#defcfunc vector_Get int self,  int idx
	if ( 0 <= idx && idx < vector_Size(self) ) {
		return list_get( vector_GetImpl(self), idx )
		
	} else {
		// ͈͊OI
		PutError Error_InvalidIndex
		return 0
	}
	
//------------------------------------------------
// WJς݂H
// 
// @ Vector ̃CX^XłȂ => indet
//------------------------------------------------
#defcfunc vector_IsExpanded int self,  local iVar
	iVar = assoc_Find(self, "#bExpanded")
	return which( iVar < 0, indet, var_Get( iVar ) )
	
#define global vector_BeExpanded(%1, %2 = true) var_Set assoc_Find((%1), "#bExpanded"), (%2), Valtype_Bool

//##########################################################
//                ǉE
//##########################################################
//------------------------------------------------
// ǉ (Impl)
// 
// @return = int : ϐID
//------------------------------------------------
#define global vector_AddImpl(%1, %2, %3, %4, %5 = "#") VAR_TEMP@MCVector = (%3) : vector_AddImpl_ %1, %2, VAR_TEMP@MCVector, %4, %5
#deffunc vector_AddImpl_ int self,  int idx, var defval, int valtype,  str name,  local iVar
	
	// ϐ`
	var_New name, defval, valtype, self
	iVar = stat
	
	vector_ImportVar self, idx, iVar
	return iVar
	
#define global vector_Insert(%1, %2, %3 = 0, %4 = Valtype_Int, %5 = "#") vector_AddImpl (%1), %2, %3, %4, %5
#define global vector_PushBack(%1, %2 = 0, %3 = Valtype_Int, %4 = "#")   vector_AddImpl (%1), vector_Size(%1), %2, %3, %4
#define global vector_PushFront(%1, %2 = 0, %3 = Valtype_Int, %4 = "#")  vector_AddImpl (%1), 0, %2, %3, %4

//------------------------------------------------
// ǉ(ϐ)
// 
// @return = int : ϐID
//------------------------------------------------
#deffunc vector_ImportVar int self,  int idx, int iVar
	list_insert vector_GetImpl(self), iVar, idx
	return iVar
	
#deffunc vector_ReplaceVar int self,  int idx, int iVar
	list_set vector_GetImpl(self), iVar, idx
	return iVar
	
//------------------------------------------------
//  (Impl)
//------------------------------------------------
#deffunc vector_RemoveImpl int self,  int idx,  local result, local impl
	impl   = vector_GetImpl(self)
	result = list_get( impl, idx )
	list_remove impl, idx
	return result
	
#define global vector_Remove(%1, %2)   vector_RemoveImpl (%1), %2
#define global vector_PopBack(%1, %2)  vector_RemoveImpl (%1), (vector_Size(%1) - 1)
#define global vector_PopFront(%1, %2) vector_RemoveImpl (%1), 0

//------------------------------------------------
// vfݒ
//------------------------------------------------
#deffunc vector_SetSize int self,  int newlen,  local curlen, local impl
	impl = vector_GetImpl(self)
	
	list_setSize impl, newlen
	curlen = stat
	
	//  or s
	if ( curlen >= newlen ) {
		;
		
	// 
	} else {
		// VKvf (VKϐ placement-new I)
		repeat newlen - curlen, curlen
			var_New "#", assocNull, Valtype_Assoc, self
			list_set impl, stat, cnt
		loop
	}
	
	return
	
//##########################################################
//                
//##########################################################
#deffunc vector_Move int self,  int idxSrc, int idxDst
	list_move vector_GetImpl(self), idxSrc, idxDst
	return
	
#deffunc vector_Swap int self, int idxSrc, int idxDst
	list_swap vector_GetImpl(self), idxSrc, idxDst
	return
	
#define global vector_Reverse(%1, %2 = 0, %3 = ArrayRangeEndDefault) vector_Reverse_ %1, %2, %3
#deffunc vector_Reverse_ int self,  int iBgn, int iEnd
	list_reverse vector_GetImpl(self), iBgn, which( iEnd != ArrayRangeEndDefault, iEnd, vector_Size(self) )
	return
	
//##########################################################
//                XCX
//##########################################################
//------------------------------------------------
// ԃXCX
// 
// @ (a == b) => [ ]
// @ (a <  b) =>  [a, b) ̃XCX
// @ (a >  b) =>  (b, a] ̃XCX reverse()
//------------------------------------------------
#define global ctype vector_Slice(     %1, %2 = 0, %3 = ArrayRangeEndDefault        ) vector_Slice_(%1, %2, %3)
#define global       vector_SliceRange(%1, %2 = 0, %3 = ArrayRangeEndDefault, %4, %5) vector_SliceRange_ %1, %2, %3, %4, %5

#defcfunc vector_Slice_ int self,  int a, int b,   local range, local result, local bReverse, local tmp, local iElem
	result = vector_DupEmpty(self)
	
	// XCX
	vector_SliceRange self, a, b, range, bReverse
	if ( stat == 0  ) { return result }
	
	if ( range(0) < 0 || vector_Size(self) < range(1) ) { PutError Error_InvalidIndex }
	
	// XCX
	iElem = 0
	repeat range(1) - range(0), range(0)		//  [ range(0), range(1) ) Ŕ
		vector_ImportVar result, iElem, vector_Get(self, cnt)
		iElem ++
	loop
	
	if ( bReverse ) { vector_Reverse result }
	return result
	
// XCXԂ𓾂
// @ result: vf
#deffunc vector_SliceRange_ int self, int a, int _b, array range, var bReverse,   local b
	
	b = which( _b != ArrayRangeEndDefault, _b, vector_Size(self) )
	if ( a == b ) { return 0 }
	
	if ( a < b ) {
		range    = a, b
		bReverse = false
	} else {
		range    = b + 1, a + 1
		bReverse = true
	}
	
	return range(1) - range(0)
	
//------------------------------------------------
// wXCX
// 
// @prm idx[] : XCXɒǉvfԍXg
//------------------------------------------------
#defcfunc vector_Pick int self,  array idxlist,  local iElem, local result
	result = vector_DupEmpty(self)
	
	foreach idxlist
		vector_ImportVar result, cnt, vector_Get(self, idxlist(cnt))
	loop
	
	return result
	
#defcfunc vector_PickOne int self, int idx,  local idxlist
	idxlist = idx
	return vector_Pick( self, idxlist )
	
//------------------------------------------------
// AXCX
// 
// @result: self->slice()->chain(src)
//------------------------------------------------
#defcfunc vector_Cat int self, int src,  local result
	result = vector_Slice(self)
	vector_Chain result, src		// self->slice() + src
	return result
	
//##########################################################
//                Rei
//##########################################################
//------------------------------------------------
// 󕡐 @private
// 
// @ vfȊOSĕ vector 𐶐
//------------------------------------------------
#defcfunc vector_DupEmpty int self,  local newOne
	newOne = new_vector( vector_GetEnv(self) )	// ŋ vector
	
	assoc_SetPrototype newOne, assoc_GetPrototype(self)
	if ( vector_IsExpanded(self) ) {
		vector_BeExpanded newOne
	}
	
	return newOne
	
//------------------------------------------------
// 
//------------------------------------------------
#defcfunc vector_Dup int self,   local impl, local iVar, local obj
	obj  = vector_DupEmpty(self)
	
	impl = vector_GetImpl(self)
	repeat list_size( impl )
		iVar = list_get( impl, cnt )
		vector_AddImpl obj, cnt, var_Get(iVar), var_GetType(iVar)
	loop
	
	return obj
	
//------------------------------------------------
// A
// 
// @prm src : vector
//------------------------------------------------
#deffunc vector_Chain int self, int src,  local impl, local offset
	offset = vector_Size(self)
	
	impl = vector_GetImpl(src)
	repeat list_size( impl )
		vector_ImportVar self, cnt + offset, list_get(impl, cnt)
	loop
	
	return
	
//##########################################################
//                R}h⏕
//##########################################################
//------------------------------------------------
// Yt
// 
// @prm arglist : w肳ꂽY
//------------------------------------------------
#defcfunc vector_EnIndex int self_, var resVt, int arglist, int cntArgs,  \
	local self, local tmp, local tmp_vt
	
	self = self_
	
	resVt = Valtype_Assoc	// self ̌^ƂĎgp
	
	// SԃXCX []
	if ( cntArgs == 0 ) {
		return vector_Slice(self)
	}
	
	repeat cntArgs
		if ( resVt == Valtype_Var ) {
			self  = var_Get( self )			// 2Tڈȍ~ tmp(0): iVar Ȃ̂ŁAϐWJ
			resVt = Valtype_Assoc
		}
		
		tmp = var_GetValue( vector_Get(arglist, cnt), tmp_vt )
		
		// [idx] : vfw
		if ( tmp_vt == Valtype_Int ) {
			self  = vector_Get( self, tmp )
			resVt = Valtype_Var
			
		// [a:b] : ԃXCX
		} elsif and( tmp_vt == Valtype_Assoc, assoc_InstOf(tmp, stt_assoc_pair) ) {
			self = vector_EnIndex_Slice( self, resVt, tmp )
			
		// [ [a, b, c, ...] ] : wXCX
		} elsif and( tmp_vt == Valtype_Assoc, assoc_InstOf(tmp, stt_assoc_vector) ) {
			self = vector_EnIndex_Pick( self, resVt, tmp )
			
		// [ ]
		} elsif ( IsOmission(tmp, tmp_vt) ) {
		;	continue
			
		// error
		} else {
			PutErrorImpl Error_InvalidValue
		}
		
		if ( stt_error ) { break }
	loop
	
	return self
	
//------------------------------------------------
// Yt / ԃXCX
// 
// @prm range : Ԃ
//------------------------------------------------
#defcfunc vector_EnIndex_Slice int self, var resVt, int range,  local lhs, local rhs
	
	lhs = assoc_Find( range, "lhs" )
	rhs = assoc_Find( range, "rhs" )
	if ( var_GetType(lhs) != Valtype_Int || var_GetType(rhs) != Valtype_Int ) { PutError Error_NeedInt }
	
	resVt = Valtype_Assoc
	return vector_Slice( self, var_Get(lhs), var_Get(rhs) )
	
//------------------------------------------------
// Yt / wXCX
// 
// @prm idxes    : Y\ vector
// @	idxes[x] : Y or Y 
//------------------------------------------------
#defcfunc vector_EnIndex_Pick int self, var resVt, int idxes,  \
	local idxlist, local cntIdxes, local tmp, local tmp_vt
	
;	dim idxlist
;	cntIdxes = 0
	
	repeat vector_Size(idxes)
		tmp = var_GetValue( vector_Get(idxes, cnt), tmp_vt )
		
		if ( tmp_vt == Valtype_Int ) {
			idxlist( cntIdxes ) = tmp : cntIdxes ++
			
		} elsif and( tmp_vt == Valtype_Assoc, assoc_InstOf(tmp, stt_assoc_pair) ) {
			vector_EnIndex_Pick_RangeToIdxlist self, idxlist, cntIdxes, tmp
			
		// error
		} else {
			PutErrorImpl Error_InvalidValue
		}
	loop
	
	resVt = Valtype_Assoc
	return which( cntIdxes == 0, vector_DupEmpty(self), vector_Pick( self, idxlist ) )
	
// XCX()  Y
#deffunc vector_EnIndex_Pick_RangeToIdxlist int self, array idxlist, var cntIdxes, int pairRange,  local lhs, local rhs, local range, local bReverse, local size
	
	lhs = assoc_Find( pairRange, "lhs" )
	rhs = assoc_Find( pairRange, "rhs" )
	if ( var_GetType(lhs) != Valtype_Int || var_GetType(rhs) != Valtype_Int ) { PutError Error_NeedInt }
	
	vector_SliceRange self, var_Get(lhs), var_Get(rhs), range, bReverse
	if ( stat == 0 ) { return 0 }
	size = stat
	
	//   Y
	repeat size, range(0)
		idxlist( cntIdxes ) = cnt : cntIdxes ++
	loop
	if ( bReverse ) { ArrayReverse idxlist, cntIdxes - size, cntIdxes }		// ǉY̋Ԃ𔽓]
	
	return size
	
#global

#endif
