// StrCalcLexer - cutToken

#ifndef IG_MODULE_STRCALC_LEXER_CUT_TOKEN_AS
#define IG_MODULE_STRCALC_LEXER_CUT_TOKEN_AS

//##############################################################################
//                g[N؂oW[
//##############################################################################
#module mod_StrCalcLexer_cutToken

#include "header_inner.as"
#include "Mo/ctype.as"

// @static i, c

//------------------------------------------------
// ͈͂̈Ⴄug[Nv؂oĕԂ
//------------------------------------------------
#define FTM_CutToken(%1,%2=0) \
	i = iOffset :\
	repeat :\
		c = peek(sSrc, i) :\
		if ((%1) == false || c == 0) { break } \
		if (%2) { i ++ }\
		i ++ :\
	loop :\
	stt_len = i - iOffset :\
	result  = strmid(sSrc, iOffset, stt_len)
	
//------------------------------------------------
// ʎq؂oĕԂ
//------------------------------------------------
#deffunc CutIdentifier var result, var sSrc, int iOffset
	FTM_CutToken ( IsIdent(c) || IsSJIS1st(c) ), IsSJIS1st(c)
	return
	
//------------------------------------------------
// NiŎgpł镶ǂ
// 
// @! 2 <= N <= 32
//------------------------------------------------
#defcfunc IsNumRadix int sSrc, int radix
	if ( not (2 <= radix && radix <= 32) || ( not IsDigit(sSrc) && not IsAlpha(sSrc) ) ) {
		return false
	}
	
	// ɂ
	c = which( IsAlphaUp(sSrc), sSrc - 'A' + 'a', sSrc )
	
	// 10i܂łȂ琔̂ݎg
	if ( radix <= 10 ) {
		return ( radix > (c - '0') )
		
	// ȏȂAt@xbgg
	} else {
		return ( radix > (c - 'a' + 10) )
	}
;	return
	
//------------------------------------------------
// N i؂oĕԂ
// 
// @! 2 <= N <= 32
//------------------------------------------------
#defcfunc CutNum_Radix var sSrc, int iOffset, int radix,  local result
	FTM_CutToken ( IsNumRadix(c, radix) || (i > iOffset && c == '_') /*|| ( radix == 10 && c == '.' )*/ )
	return result
	
//------------------------------------------------
// 16i؂oĕԂ
//------------------------------------------------
#define global ctype CutNum_Hex(%1, %2 = 0) CutNum_Radix(%1, %2, 16)
#define global ctype CutNum_Bin(%1, %2 = 0) CutNum_Radix(%1, %2, 2)
#define global ctype CutNum_Dgt(%1, %2 = 0) CutNum_Radix(%1, %2, 10)

//------------------------------------------------
// 󔒂؂oĕԂ
//------------------------------------------------
#deffunc CutBlank var result, var sSrc, int iOffset
	FTM_CutToken ( IsBlank(c) )
	return
	
//------------------------------------------------
// sRg؂oĕԂ
//------------------------------------------------
#deffunc CutCommentLine var result, var sSrc, int iOffset,  local iFound
	iFound  = instr(sSrc, iOffset, "\n")
	stt_len = which( iFound >= 0, iFound + 2, strlen(sSrc) - iOffset )
	
;	getstr result, sSrc, iOffset
;	stt_len = strsize
	return
	
//------------------------------------------------
// ͈̓Rg؂oĕԂ (lXgȂ)
// 
// @prm [sBgn, sEnd]: ͈͎w蕶
//------------------------------------------------
#deffunc CutCommentRange var result, var sSrc, int iOffset, str sBgn, str sEnd,  local lenBgn, local lenEnd, local iFound
	lenBgn  = strlen(sBgn)
	lenEnd  = strlen(sEnd)
	
	iFound  = instr( sSrc, iOffset + lenBgn, sEnd )
	stt_len = which( iFound >= 0,  lenBgn + iFound + lenEnd,  strlen(sSrc) - iOffset )
	
;	result = strmid(sSrc, iOffset, stt_len)
	return
	
//------------------------------------------------
// ͈̓Rg؂oĕԂ (lXg)
// 
// @prm [sBgn, sEnd]: ͈͎w蕶
//------------------------------------------------
#deffunc CutCommentRangeNested var result, var sSrc, int iOffset, str sBgn, str sEnd,  local lenBgn, local lenEnd, local idx, local iFoundBgn, local iFoundEnd, local nest
	
	lenBgn = strlen(sBgn)
	lenEnd = strlen(sEnd)
	
	idx  = iOffset + lenBgn
	nest = 1					// idx ʒu̐[ ( ŏ1ڂ sBgn ̒Ȃ̂ŁA1 )
	
	repeat
		// sBgn, sEnd 𗼕
		iFoundBgn = instr( sSrc, idx, sBgn )
		iFoundEnd = instr( sSrc, idx, sEnd )
		
		// sEnd ̑O sBgn 
		if ( iFoundBgn >= 0 && iFoundBgn < iFoundEnd ) {
			nest ++						// lXg
			idx += iFoundBgn + lenBgn	// sBgn ̒ɐݒ
			
		// nest 1炷
		} else {
			if ( iFoundEnd < 0 ) {		// I[Ȃ => Ō܂
				nest = 0				// lXgSĉ
				idx = strlen(sSrc)
				logmes "[Warning] lXgt͈̓Rg [\"" + sBgn + "\", \"" + sEnd + "\"] ĂȂB\n(Jnʒu: " + iOffset + ")"
			} else {
				nest --
				idx += iFoundEnd + lenEnd
			}
		}
		
		if ( nest == 0 ) { break }		// Rg擾I
	loop
	
	stt_len = idx - iOffset
	
;	result = strmid(sSrc, iOffset, stt_len)
	return
	
//------------------------------------------------
// s؂oĕԂ
// 
// @ escseq WJB
//------------------------------------------------
#deffunc CutStringLine var result, var sSrc, int iOffset,  local k
	i = iOffset + 1
	k = 0
	repeat
		c = peek(sSrc, i)
		switch ( c )
		;	case 0x0A:
		;	case 0x0D:
			case '\"': i ++		// I[
			case 0:
				poke result, k, 0x00 : k ++
				break
				
			case '\t':			// 
				i ++
				swbreak
				
			case '\\':			// escseq
				i ++
				
				c = peek(sSrc, i)
				switch ( c )
					case 't':  c = '\t' : swbreak		// ^u
					case '0':  c = 0    : swbreak		// NULLI[
					case '\\':          : swbreak		// ASCIIR[h (0x5C)
					
					case 'n':
						i ++
						wpoke result, k, 0x0A0D : k += 2		// CRLF
						continue
						
					case 0x0D:							// s
					case 0x0A:
						if ( swthis == 0x0D && peek(sSrc, i + 1) == 0x0A ) { i ++ }	// CRLF
						i ++
						continue
						
				;	default:
				swend
				go_default
				
			case_if ( IsSJIS1st(c) ):
				wpoke result, k, wpeek(sSrc, i) : i += 2 : k += 2
				swbreak
				
			default:
				i ++
				poke result, k, c : k ++
				swbreak
		swend
	loop
	
	stt_len = 1 + (i - (iOffset + 1))
	return
	
//------------------------------------------------
// ؂oĕԂ
// 
// @ escseq ȂB
//------------------------------------------------
#deffunc CutStringRaw var result, var sSrc, int iOffset,  local iFound
	iFound = instr(sSrc, iOffset, "\">")
	if ( iFound < 0 ) {
		iFound = strlen(sSrc) - iOffset					// Ō܂
	}
	
	result  = strmid(sSrc, iOffset + 2, iFound - 2)		// ʂ͏
	stt_len = iFound + 2
	return
	
//------------------------------------------------
// Ōɐ؂og[N̒
//------------------------------------------------
#defcfunc StrCalcLexer_GetLenCutLast
	return stt_len
	
#global

#endif
